## metview 5.26.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
#set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )


project( MetviewMiniBundle VERSION 5.26.2 LANGUAGES C CXX )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    #list(APPEND MV_BUNDLE_PACKAGES FDB)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")
set(ENABLE_FORTRAN       NOT_SET CACHE BOOL "Fortran features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL "")
set(ENABLE_MPI        OFF CACHE BOOL "")
set(ENABLE_BUILD_TOOLS  OFF   CACHE BOOL   "")


# if the user did bot supply a value for ENABLE_FORTRAN, then unset it
# (we want to then use the default behaviour, per package)
if(ENABLE_FORTRAN STREQUAL "NOT_SET")
    unset(ENABLE_FORTRAN)
    unset(ENABLE_FORTRAN CACHE)
endif()


# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

include( ecbuild_bundle )

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                GIT "ssh://git@git.ecmwf.int/mars/fdb_vintage"    TAG  4.11.0   )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        GIT "ssh://git@git.ecmwf.int/ecsdk/eckit"       TAG  1.32.4   )
    #my_bundle_pkg( PROJECT atlas        GIT "ssh://git@git.ecmwf.int/atlas/atlas"       TAG  0.44.0   )
    my_bundle_pkg( PROJECT atlas        GIT "https://github.com/ecmwf/atlas.git"       TAG  0.45.0   )
    #my_bundle_pkg( PROJECT mir          GIT "ssh://git@git.ecmwf.int/mir/mir"           TAG  1.23.0   )
    my_bundle_pkg( PROJECT mir          GIT "https://github.com/ecmwf/mir.git"           TAG  1.27.8   )
    my_bundle_pkg( PROJECT mars-client  GIT "ssh://git@git.ecmwf.int/mars/mars-client"  TAG  6.33.25  )
    my_bundle_pkg( PROJECT metview      GIT "ssh://git@git.ecmwf.int/metv/metview"      TAG  5.26.2   )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== atlas/pluto/src/CMakeLists.txt ===
# (C) Copyright 2013- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


#pluto_host_device( pluto_host_device_src SOURCE pluto/device/MemoryResource.cc)

set(PLUTO_HAVE_CUDA ${HAVE_CUDA} )
set(PLUTO_HAVE_HIP  ${HAVE_HIP} )
set(PLUTO_HAVE_HIC  0)

if( HAVE_CUDA OR HAVE_HIP )
  set(PLUTO_HAVE_HIC 1)
endif()

configure_file(pluto/pluto_config.h.in pluto/pluto_config.h @ONLY )
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pluto/pluto_config.h
  DESTINATION
    ${INSTALL_INCLUDE_DIR}/pluto
)

if (NOT HAVE_PMR)
  list( APPEND pmr_compat_src
      pluto/memory_resource/compat/memory_resource
      pluto/memory_resource/compat/memory_resource.cc
  )
  install(
    FILES
      pluto/memory_resource/compat/memory_resource
    DESTINATION
      ${INSTALL_INCLUDE_DIR}/pluto/memory_resource/compat
  )
endif()

ecbuild_add_library( TARGET pluto
  SOURCES
    pluto/pluto.h
    ${CMAKE_CURRENT_BINARY_DIR}/pluto/pluto_config.h

    pluto/device/allocator.h
    pluto/device/MemoryResource.cc
    pluto/device/MemoryResource.h

    pluto/host/allocator.h
    pluto/host/MemoryResource.cc
    pluto/host/MemoryResource.h

    pluto/memory.cc
    pluto/memory.h
    pluto/memory_resource.h
    pluto/memory_resource/AsyncMemoryResourceAdaptor.cc
    pluto/memory_resource/AsyncMemoryResourceAdaptor.h
    pluto/memory_resource/DeviceMemoryResource.cc
    pluto/memory_resource/DeviceMemoryResource.h
    pluto/memory_resource/HostMemoryResource.cc
    pluto/memory_resource/HostMemoryResource.h
    pluto/memory_resource/ManagedMemoryResource.cc
    pluto/memory_resource/ManagedMemoryResource.h
    pluto/memory_resource/memory_resource.cc
    pluto/memory_resource/MemoryPoolResource.cc
    pluto/memory_resource/MemoryPoolResource.h
    pluto/memory_resource/MemoryResourceAdaptor.h
    pluto/memory_resource/PinnedMemoryResource.cc
    pluto/memory_resource/PinnedMemoryResource.h
    pluto/memory_resource/TraceMemoryResource.cc
    pluto/memory_resource/TraceMemoryResource.h
    pluto/memory_resource/detail/GatorMemoryResource.cc
    pluto/memory_resource/detail/GatorMemoryResource.h
    pluto/memory_resource/detail/yakl/YAKL_Gator.h
    pluto/memory_resource/detail/yakl/YAKL_LinearAllocator.h

    pluto/alignment.h
    pluto/copy.h
    pluto/event.cc
    pluto/event.h
    pluto/memcpy.cc
    pluto/memcpy.h
    pluto/pointer_info.cc
    pluto/pointer_info.h
    pluto/prefetch.cc
    pluto/prefetch.h
    pluto/runtime.cc
    pluto/runtime.h
    pluto/scope.cc
    pluto/scope.h
    pluto/stream.cc
    pluto/stream.h
    pluto/trace.cc
    pluto/trace.h
    pluto/wait.cc
    pluto/wait.h
    
    pluto/detail/Registry.h

    ${pmr_compat_src}
    pluto/mdspan.h
    pluto/detail/mdspan_paren_operator.h
    pluto/detail/mdspan/mdspan.hpp

  INSTALL_HEADERS ALL
  HEADER_DESTINATION include
  PUBLIC_LIBS hic
  PUBLIC_INCLUDES
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
      $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

target_compile_features( pluto INTERFACE cxx_std_17 )
target_compile_options( pluto PUBLIC $<$<COMPILE_LANGUAGE:CUDA>:--extended-lambda>)

if (HAVE_FORTRAN)
  set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module/pluto)
  ecbuild_add_library( TARGET pluto_f
    SOURCES
      pluto_f/pluto_module.F90
      pluto_f/pluto_module.cc
    PRIVATE_LIBS pluto
    PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
                    $<INSTALL_INTERFACE:module/pluto>
  )
  if( ECBUILD_INSTALL_FORTRAN_MODULES )
    install( DIRECTORY ${CMAKE_BINARY_DIR}/module/pluto/
             DESTINATION module/pluto
             COMPONENT modules )
  endif()
endif()

=== atlas/src/tests/field/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_test( TARGET atlas_test_fieldset
    SOURCES test_fieldset.cc
    LIBS atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_field_missingvalue
    SOURCES     test_field_missingvalue.cc
    LIBS        atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_field_memory_resource
    SOURCES     test_field_memory_resource.cc
    LIBS        atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_field_foreach
  SOURCES  test_field_foreach.cc
  LIBS     atlas
  OMP      4
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  CONDITION NOT SKIP_TEST_atlas_test_field_foreach
)

set( _WITH_MPI )
if( eckit_HAVE_MPI )
    set( _WITH_MPI MPI 4 CONDITION MPI_SLOTS GREATER_EQUAL 4)
endif()

ecbuild_add_test( TARGET atlas_test_field_halo
  SOURCES test_field_halo.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  ${_WITH_MPI}
)

set( HAVE_ACC_CXX FALSE )
if( TARGET OpenACC::OpenACC_CXX AND atlas_HAVE_ACC )
  set( HAVE_ACC_CXX TRUE )
endif()
ecbuild_add_test( TARGET atlas_test_field_acc
  SOURCES  test_field_acc.cc
  LIBS     atlas OpenACC::OpenACC_CXX
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT} ATLAS_RUN_NGPUS=1
  CONDITION HAVE_ACC_CXX
)
ecbuild_add_test( TARGET atlas_test_field_acc_cpu
  SOURCES  test_field_acc.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)
if( TEST atlas_test_field_acc )
    set_tests_properties ( atlas_test_field_acc PROPERTIES LABELS "gpu;acc")
endif()

ecbuild_add_test( TARGET atlas_test_multifield_ifs
  SOURCES         test_multifield_ifs.cc
  LIBS            atlas
  ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
)

if( HAVE_FCTEST )

  add_fctest( TARGET atlas_fctest_multifield_ifs
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_multifield_ifs.F90
    LIBS            atlas_f pluto_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_field
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )
  
  add_fctest( TARGET atlas_fctest_field_wrap
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_wrap.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_field_view
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_view.F90
    LIBS            atlas_f OpenMP::OpenMP_Fortran
    OMP             3
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
    CONDITION       atlas_HAVE_OMP_Fortran
  )

  add_fctest( TARGET atlas_fctest_field_host
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_host.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_field_device
    CONDITION       atlas_HAVE_ACC
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_gpu.F90 external_acc_routine.F90
    LIBS            atlas_f OpenACC::OpenACC_Fortran
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT} ATLAS_RUN_NGPUS=1
  )

  if( TARGET atlas_fctest_field_device )
    set_tests_properties ( atlas_fctest_field_device PROPERTIES LABELS "gpu;acc")
  endif()

  add_fctest( TARGET atlas_fctest_fieldset_device
    CONDITION       atlas_HAVE_ACC
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_fieldset_gpu.F90
    LIBS            atlas_f OpenACC::OpenACC_Fortran
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT} ATLAS_RUN_NGPUS=1
  )

  if( TARGET atlas_fctest_fieldset_device )
    set_tests_properties ( atlas_fctest_fieldset_device PROPERTIES LABELS "gpu;acc")
  endif()


  add_fctest( TARGET atlas_fctest_field_wrap_device
    CONDITION       atlas_HAVE_ACC
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_wrap_gpu.F90 external_acc_routine.F90
    LIBS            atlas_f OpenACC::OpenACC_Fortran
    DEFINITIONS     HAVE_NOREPACK=${HAVE_NOREPACK}
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT} ATLAS_RUN_NGPUS=1
  )

  if( TARGET atlas_fctest_field_wrap_device )
    set_tests_properties ( atlas_fctest_field_wrap_device PROPERTIES LABELS "gpu;acc")
  endif()

endif()

=== debian/changelog ===
metview (5.26.2-2) unstable; urgency=medium

  * Drop unused libemos-dev dependencies
  * Build-dep on libcups2-dev for printing control

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Jan 2026 05:49:11 +0000

metview (5.26.2-1) unstable; urgency=medium

  * New upstream release
  * d/gpb.conf: upstream branch now upstream/latest
  * gdb.conf: use debian/latest
  * d/control: Drop priority: Optional
  * Standards-Version: 4.7.3
  * Lintian overrides for wierd script

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Jan 2026 17:26:27 +0000

=== debian/control ===
Source: metview
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-2),
  gfortran | fortran-compiler, 
  python3-all-dev,
  libgeotiff-dev,
  flex, 
  bison, 
  libcups2-dev,
  libtirpc-dev,
  libncurses-dev,
  libjemalloc-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libmetkit-dev,
  libmetkit-utils,
  fdb5,
  libfdb5-dev (>= 5.16.1~),
  odc,
  libodc-dev,
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libfckit-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  libvulkan-dev,
  libxkbcommon-dev,
  libeccodes-dev (>= 2.22.0),
  libeccodes-tools,
  libatlas-ecmwf-dev (>= 0.42.0~), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.10.1~),
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev (>= 4.12.1-2), 
  libmagics++-dev (>= 4.12.1-2),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkgconf,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, 
  flextra, 
  flexpart
Standards-Version: 4.7.3
Homepage: https://confluence.ecmwf.int/display/METV/Metview
Vcs-Browser: https://salsa.debian.org/science-team/metview
Vcs-Git: https://salsa.debian.org/science-team/metview.git -b debian/latest

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3, ${perl:Depends}
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1


DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
DEB_CXXFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++17 -I /usr/include/eigen3


# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

# Code should import these from eccodes-import but doesn't
export ECCODES_SAMPLES_PATH=/usr/share/eccodes/samples
export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions
export ECCODES_IFS_SAMPLES_PATH=/usr/share/eccodes/ifs_samples

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin
export BUILDDIR=$(METVIEW_DIR_DEV)


# Hack until complter  uses this directory
FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
FMODDIR:=$(LIBDIR)/fortran/$(FC)
FCFLAGS:=$(shell dpkg-buildflags --get FCFLAGS) -I $(FMODDIR)

# For bit reproducibility
LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

# magic debhelper rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=$(BUILDDIR)

#override_dh_auto_clean:
#	dh_auto_clean
#	rm -f metview/src/images/metview.png

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/share/mir/masks
	( cd $(BUILDDIR)/share/mir/masks ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	dh_auto_configure -- \
		-DENABLE_EXPOSE_SUBPACKAGES=On \
		-DENABLE_BUILD_TOOLS=On \
		-DENABLE_PPROC_MIR=On \
		-DENABLE_PPROC_EMOS=Off \
		-DENABLE_URL_DOWNLOAD=On \
		-DENABLE_MPI=On \
		-DENABLE_ODB=On \
		-DENABLE_FDB5=On \
		-DENABLE_PNG=On \
		-DENABLE_RPC=On \
		-DRPC_PATH=${LIBDIR} \
		-DENABLE_MIR_DOWNLOAD_MASKS=On \
		-DENABLE_EXPERIMENTAL=Off \
		-DENABLE_CODE_WEBHELP=Off \
		-DENABLE_CONTRIB=On \
		-DCMAKE_CXX_STANDARD=17 \
		-DCMAKE_CXX_STANDARD_REQUIRED=On \
		-DMETVIEW_SITE=debian  \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -leccodes -leckit -leckit_option' \
		-DMETVIEW_EXTRA_INCLUDE_DIRS=/usr/include/terralib/kernel \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DCMAKE_Fortran_FLAGS='$(FCFLAGS)'  

	( cd ${METVIEW_DIR_DEV}/share ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	# cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	# cp metview/src/images/metview_logo.png metview/src/images/metview.png

override_dh_auto_test:
	# Don't fail on tests in this build
	@echo "Ignoring test failures this build"
	# -( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  )

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	# chmod 755 debian/metview/$(MV_DIR)/mv_compress
	mv debian/metview/$(MV_DIR)/metview_bin/* debian/metview/$(MV_DIR)
	rmdir debian/metview/$(MV_DIR)/metview_bin
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/lib/*/metview/*.mv
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.*

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \;
